package com.example.sam4s;

import com.example.sam4s.R;
import com.sam4s.printer.Sam4sBuilder;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;

public class cl_Cut extends Activity {
	static final int SEND_TIMEOUT = 10 * 1000;

    boolean exitActivity = false;

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.cut);

        //check close port
        if(cl_Menu.mPrinter == null){
            finish();
            return ;
        }
    
        //init type list
        Spinner spinner = (Spinner)findViewById(R.id.spinner_type);
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        adapter.add(getString(R.string.cuttype_nofeed));
        adapter.add(getString(R.string.cuttype_feed));
        spinner.setAdapter(adapter);
        spinner.setSelection(1);

        //Registration ClickListener
        Button button = (Button)findViewById(R.id.button_print);
        button.setOnClickListener(new btnPrintClick());
    }
    
    @Override
    public void onDestroy() {
        super.onDestroy();
        if(!exitActivity){
            try {
            	cl_Menu.mPrinter.closePrinter();
			} catch (Exception e) {				
				e.printStackTrace();
			}
        }
    }
    
    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if(keyCode == KeyEvent.KEYCODE_BACK){
            exitActivity = true;
        }
        
        return super.onKeyDown(keyCode, event);
    }
    
    class btnPrintClick implements View.OnClickListener {
 		@Override
		public void onClick(View arg0) {
 			cut();
		}
    }
    
    private void cut(){
        try{
        	Sam4sBuilder mBuilder = null;
        
            //create builder
            Intent intent = getIntent();
            //Builder
            mBuilder = new Sam4sBuilder(
                    intent.getStringExtra("printername"), intent.getIntExtra("language", 0));

            //add command
            //addCut
            mBuilder.addCut(getBuilderType());

            //send builder data
            try{
            	cl_Menu.mPrinter.sendData(mBuilder);                
            }catch(Exception e){
                e.getStackTrace();
            }
            
          //remove builder
            if(mBuilder != null){
                try{
                	mBuilder.clearCommandBuffer();
                	mBuilder = null;
                }catch(Exception e){
                	mBuilder = null;
                }
            }
        }catch(Exception e){
        	cl_Main.showMsg(e.getLocalizedMessage(), this);
        }   
    }

    private int getBuilderType() {
        Spinner spinner = (Spinner)findViewById(R.id.spinner_type);
        switch(spinner.getSelectedItemPosition()){
        case 1:
            return Sam4sBuilder.CUT_FEED;
        case 0:
        default:
            return Sam4sBuilder.CUT_NO_FEED;
        }
    }
}
